  DEFINT A-Z
     
  DECLARE SUB LoadMusic (MusicName AS STRING, MusicType AS INTEGER, MusicChannel AS INTEGER, Repeat AS INTEGER, Enable3D AS INTEGER)
  DECLARE SUB LoadSample ()
  DECLARE SUB PlaySample (SampleNumber AS INTEGER)
  DECLARE SUB RemoveMusic (Channel AS INTEGER)
  DECLARE SUB SetEAX (EaxCode AS INTEGER)
  DECLARE SUB SetVolume (MODVol AS INTEGER, SAMVol AS INTEGER, MP3Vol AS INTEGER)
  DECLARE SUB WaitforDMA0 ()

  DECLARE SUB EndTurn ()
  DECLARE SUB AsteroidOptions ()
 
  DECLARE SUB BOX (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, col AS INTEGER)
  DECLARE SUB Arrow (x1 AS INTEGER, y1 AS INTEGER, x3 AS INTEGER, y3 AS INTEGER, Lenght AS INTEGER, col AS LONG)
  DECLARE SUB center (x1 AS INTEGER, y1 AS INTEGER, text AS STRING, col AS LONG)
  DECLARE SUB Spin (x1 AS DOUBLE, y1 AS DOUBLE, speed AS DOUBLE, range AS INTEGER, col AS LONG)
  DECLARE SUB Circ (x1 AS DOUBLE, y1 AS DOUBLE, speed AS DOUBLE, range AS INTEGER, col AS LONG)

  REM $INCLUDE: 'data\future.bi'

  IF IsXMSInstalled = 0 THEN PRINT "XMS not installed": END
  IF IsVESA <> -1 THEN PRINT "VESA not installed": END

  RANDOMIZE TIMER
  CONST pi = 3.141592653589793#
  CONST AsteroidFrameAmount = 81
  CONST AsteroidFrameSize = 50
  CONST ParticleAmount = 800
  CONST ShipThick = 64
  CONST CollisionAmount = 72

DIM SHARED TrajectoryLines   AS INTEGER
DIM SHARED CollisionWarning  AS INTEGER
DIM SHARED GalaxyBackground  AS INTEGER
    TrajectoryLines = -1                 ' da li se vide putanje asteroida (-1 ne)
    CollisionWarning = -1                ' da li se vide upozorenja na sudar (-1 ne)
    GalaxyBackground = 0                 ' da li se vidi galaxija u pozadini (-1 ne)

DIM SHARED AsteroidAmount  AS INTEGER
DIM SHARED PlayerRace      AS INTEGER
DIM SHARED PlayerColor     AS LONG
    AsteroidAmount = 24                      ' broj asteroida u igri
    ShipAmount = AsteroidAmount * 9 + 1      ' broj brodova
    PlayerRace = INT(RND * 3) + 1            ' ko je igrac (0 niko 1r-2g-3b)
   ' PlayerRace = 3
    PlayerColor = 6 ^ (PlayerRace - 1)       ' boja igraca
    IF PlayerRace = 0 THEN PlayerColor = 43

DIM SHARED a  AS DOUBLE
DIM SHARED b  AS DOUBLE
DIM SHARED c  AS DOUBLE
DIM SHARED d  AS DOUBLE
DIM SHARED e  AS STRING
DIM SHARED f  AS LONG
DIM SHARED h  AS INTEGER
DIM SHARED g  AS DOUBLE   '  za sub-ove
DIM SHARED i  AS LONG     ' za sub-ove


DIM SHARED rx  AS INTEGER
DIM SHARED ry  AS INTEGER
    rx = 640              ' rezolucija x, y
    ry = 480

DIM SHARED MouseShape(4) AS STRING
DIM SHARED x             AS INTEGER
DIM SHARED y             AS INTEGER
DIM SHARED z             AS INTEGER
DIM SHARED mt1           AS STRING
DIM SHARED mt2           AS STRING
DIM SHARED up            AS INTEGER
    x = 0                            ' x pos misa
    y = 0                            ' y pos misa
    z = 0                            ' dugme misa
    mt1 = ""                         ' text kod misa
    mt2 = ""                         ' text kod misa
    up = 0                           ' "unpress"

  IF rx = 640 AND ry = 480 THEN Set640x480 8
  IF rx = 800 AND ry = 600 THEN Set800x600 8
  IF rx = 1024 AND ry = 768 THEN Set1024x768 8
 
  IF Pages <= 0 THEN
    ReSetScreen
    PRINT "Not enough pages available"
    END
    END IF

  SetMaskColor -1
  LoadPal "data\default.pal"
  Future.LoadFONT "data\default.fnt"
  SetPage 0
  Future.CLS PlayerColor
  BOX 2, 2, 637, 477, 43 + PlayerColor
  center 320, 240, "Loading, please wait", 215
  ViewPage 0
  SetPage 1

 ' OUT &H0, 0
 ' OUT &H0, 0
 ' SHELL "start /m music\ds4qb2.exe"  ' InitDS4QB
 ' SetVolume 100, 100, 100            '

 ' musicname, musictype, musicchannel, repeat, enable3d
 ' LoadMusic "music\01.MO3", 1, 1, 1, 0

  SetMouseMaskColor 8
  FOR b = 0 TO 3
    FOR a = 0 TO 255
      READ f
      MouseShape(b) = MouseShape(b) + CHR$(f)
      NEXT
    NEXT
  Future.MouseShape SADD(MouseShape(PlayerRace)), VARSEG(MouseShape(PlayerRace))
  Future.MouseOff
 
TYPE PictureType
  Scr       AS INTEGER
  Back      AS INTEGER
  Mineral   AS INTEGER
  LnAni     AS INTEGER
  Small     AS INTEGER
  AstAni    AS INTEGER
  InfoBack  AS INTEGER
  BaseBack  AS INTEGER
  Ship      AS INTEGER
  ShipBack  AS INTEGER
  ShipInfo  AS INTEGER
  ShipSmall AS INTEGER
END TYPE

DIM SHARED GifHandle AS TGIFInfo
DIM SHARED Pic       AS PictureType
    f = (rx / 4 * 3) * (ry / 4 * 3)
    Pic.Scr = AllocateXMS((rx / 4 * 3) * (ry / 4 * 3))
    Pic.Back = AllocateXMS(307200)
    Pic.Mineral = AllocateXMS(1728)
    Pic.LnAni = AllocateXMS(18240)
    Pic.Small = AllocateXMS(2700)         ' vlasnik asteroida
    Pic.AstAni = AllocateXMS(2025000)
    Pic.BaseBack = AllocateXMS(68789)       '  50% gray
    Pic.InfoBack = AllocateXMS(54289)       '  50% gray
    Pic.ShipBack = AllocateXMS(9545)        '  50% gray
    Pic.Ship = AllocateXMS(43200)
    Pic.ShipInfo = AllocateXMS(17 * 27 * 18)
    Pic.ShipSmall = AllocateXMS(10 * 15 * 18)
    Future.DefineXMSArray 24, 24, Pic.Mineral
    Future.DefineXMSArray 19, 16, Pic.LnAni
    Future.DefineXMSArray 30, 30, Pic.Small
    Future.DefineXMSArray 50, 50, Pic.AstAni
    Future.DefineXMSArray 40, 60, Pic.Ship
    Future.DefineXMSArray 17, 27, Pic.ShipInfo
    Future.DefineXMSArray 10, 15, Pic.ShipSmall
  FOR a = 0 TO rx
    Future.PSET INT(RND / 4 * rx * 3), INT(RND / 4 * ry * 3), INT(RND * 4) * 43 + 43  ' + PlayerColor
    NEXT
  Future.XMSget 0, 0, rx / 4 * 3 - 1, ry / 4 * 3 - 1, Pic.Scr

  Future.LoadGIF "gfx\galaxy.gif", 0, 0
  Future.XMSget 0, 0, 639, 479, Pic.Back
 ' Future.LoadGIF "gfx\info.gif", 0, 0
 ' Future.XMSget 0, 0, 240, 240, Pic.Info
  Future.LoadGIF "gfx\shipback.gif", 0, 0
  Future.XMSget 0, 0, 114, 82, Pic.ShipBack
  Future.LoadGIF "gfx\infoback.gif", 0, 0
  Future.XMSget 0, 0, 232, 232, Pic.InfoBack
  Future.LoadGIF "gfx\baseback.gif", 0, 0
  Future.XMSget 0, 0, 316, 216, Pic.BaseBack


 
  Future.LoadGIF "gfx\min1.gif", 0, 0
  Future.XMSArrayGet 0, 0, Pic.Mineral, 0
  Future.LoadGIF "gfx\min2.gif", 0, 0
  Future.XMSArrayGet 0, 0, Pic.Mineral, 1
  Future.LoadGIF "gfx\min3.gif", 0, 0
  Future.XMSArrayGet 0, 0, Pic.Mineral, 2
 
  Future.LoadGIF "gfx\small1.gif", 0, 0
  Future.XMSArrayGet 0, 0, Pic.Small, 0
  Future.LoadGIF "gfx\small2.gif", 0, 0
  Future.XMSArrayGet 0, 0, Pic.Small, 1
  Future.LoadGIF "gfx\small3.gif", 0, 0
  Future.XMSArrayGet 0, 0, Pic.Small, 2

  FOR a = 1 TO 3
    FOR b = 0 TO 2
      h = (a - 1) * 6 + b
      e = RIGHT$((STR$(INT(a))), 1) + RIGHT$((STR$(INT(b))), 1) + ".gif"
      Future.LoadGIF "gfx\ships\info" + e, 0, 0
      Future.XMSArrayGet 0, 0, Pic.ShipInfo, h
      Future.LoadGIF "gfx\ships\small" + e, 0, 0
      Future.XMSArrayGet 0, 0, Pic.ShipSmall, h
      Future.LoadGIF "gfx\ships\ship" + e, 0, 0
      Future.XMSArrayGet 0, 0, Pic.Ship, h
      NEXT
    NEXT

 
  FOR a = 0 TO 9
    Future.OpenAGif "gfx\ast" + RIGHT$((STR$(INT(a))), 1) + ".gif", GifHandle
    GifHandle.loopit = 1
    FOR b = 0 TO AsteroidFrameAmount - 1
      Future.putAGif 0, 0, GifHandle
      Future.XMSArrayGet 0, 0, Pic.AstAni, b + a * AsteroidFrameAmount
      NEXT
    Future.CloseAGif GifHandle
    NEXT
 
  FOR a = 1 TO 3
    Future.OpenAGif "gfx\s" + RIGHT$((STR$(INT(a))), 1) + "ani.gif", GifHandle
    GifHandle.loopit = 1
    FOR b = 0 TO 19
      Future.putAGif 0, 0, GifHandle
      Future.XMSArrayGet 0, 0, Pic.LnAni, b + (a - 1) * 20
      NEXT
    Future.CloseAGif GifHandle
    NEXT

 
DIM SHARED t    AS DOUBLE
DIM SHARED p    AS INTEGER
DIM SHARED rot  AS DOUBLE
    rot = 2 * pi * RND    ' ugao rotacije za vecinu stvari koje rotiraju
    t = 0                 ' pre timer
    p = 0                 ' page brojac

DIM SHARED FPS               AS INTEGER
DIM SHARED CurrentFrameRate  AS INTEGER
    FPS = 0                             ' brojac
    CurrentFrameRate = 0                ' trenutni fps

DIM SHARED Day    AS INTEGER
DIM SHARED Turn   AS INTEGER
DIM SHARED Thick  AS INTEGER
    Turn = 0                 ' potez
    Day = 32                 ' koliko traje potez
    Thick = Day              ' brojac dana 

DIM SHARED s   AS INTEGER
DIM SHARED ms  AS INTEGER
DIM SHARED mb  AS INTEGER
    s = -1                ' selektovani asteroid (-1 nijedan)
    ms = -1               ' selektovani meni (-1 nijedan)
    mb = -1               ' brojac za animiranje kolicine minerala

DIM SHARED lb            AS LONG  ' brojac bitscana
DIM SHARED LinesBitScan  AS LONG  ' bitscan za crtanje
    lb = 0
    LinesBitScan = 0

DIM SHARED sx  AS DOUBLE
DIM SHARED sy  AS DOUBLE
    sx = (1280 - rx) / 2  ' ekran x pos
    sy = (960 - ry) / 2   ' ekran y pos
   
TYPE CollisionType
  x     AS INTEGER
  y     AS INTEGER
  Exist AS INTEGER
  a     AS INTEGER
  b     AS INTEGER
END TYPE
DIM SHARED Coll(CollisionAmount) AS CollisionType
DIM SHARED cb                    AS INTEGER       ' brojac za sudare
    cb = 0
  FOR a = 0 TO CollisionAmount - 1
    Coll(a).Exist = -1
    Coll(a).a = 0
    Coll(a).b = 0
    Coll(a).x = 640
    Coll(a).y = 480
    NEXT

TYPE ParticleType
  x     AS DOUBLE
  y     AS DOUBLE
  Exist AS INTEGER
  Move  AS DOUBLE
  Spd   AS INTEGER
  Size  AS INTEGER
END TYPE
DIM SHARED Part(ParticleAmount)  AS ParticleType
  FOR a = 0 TO ParticleAmount - 1
    Part(a).x = 640
    Part(a).y = 480
    Part(a).Exist = 0
    Part(a).Move = 2 * pi * RND
    Part(a).Spd = INT(RND * 4) + 4
    Part(a).Size = 1
    NEXT

DIM SHARED AstSlot(AsteroidAmount, 9) AS INTEGER
DIM SHARED ShipSelect(9)              AS INTEGER
TYPE AsteroidType
  x           AS DOUBLE
  y           AS DOUBLE
  Move        AS DOUBLE   ' u stepenima
  Owner       AS INTEGER  ' -1-ne postoji 0 1-kaled 2-zileas 3-houri
  Magic       AS INTEGER  ' 0 1-fire 2-wind 3-earth 4-ice 5-water 6-thunder
  MagicColor  AS LONG
  ArrowColor  AS DOUBLE
  Animation   AS INTEGER
  FrameNumber AS INTEGER
  InRange     AS INTEGER
  Metal       AS INTEGER
  Fuel        AS INTEGER
  Crys        AS INTEGER
  Experience  AS LONG
END TYPE
DIM SHARED Ast(AsteroidAmount) AS AsteroidType
  FOR a = 0 TO AsteroidAmount - 1
    FOR b = 0 TO 8
      AstSlot(a, b) = -1
      NEXT
    DO
      Ast(a).x = RND * 1180 + 50
      Ast(a).y = RND * 860 + 50
      c = 0
      FOR b = 0 TO a - 1
        IF SQR((Ast(a).x - Ast(b).x) ^ 2 + (Ast(a).y - Ast(b).y) ^ 2) < 80 THEN c = 1
        NEXT
      LOOP UNTIL c = 0
    Ast(a).FrameNumber = INT(RND * AsteroidFrameAmount)
    Ast(a).Animation = INT(RND * 10)
    Ast(a).Metal = INT(RND * 6) + 4
    Ast(a).Fuel = INT(RND * 6) + 4
    Ast(a).Crys = INa(RND * 6) + 4
    Ast(a).Magic = INT(RND * 7)
    SELECT CASE Ast(a).Magic
      CASE 0
        Ast(a).Metal = 9
        Ast(a).Fuel = 9
        Ast(a).Crys = 9
        Ast(a).MagicColor = 43
      CASE 1
        Ast(a).MagicColor = 1
      CASE 2
        Ast(a).MagicColor = 1 + 6
      CASE 3
        Ast(a).MagicColor = 6
      CASE 4
        Ast(a).MagicColor = 6 + 36
      CASE 5
        Ast(a).MagicColor = 36
      CASE 6
        Ast(a).MagicColor = 36 + 1
      END SELECT
    Ast(a).Owner = 0
    Ast(a).Experience = 0
    Ast(a).InRange = -1
    Ast(a).Move = 2 * pi * RND
    Ast(a).ArrowColor = RND * 4 + 1
    NEXT
  FOR a = AsteroidAmount - 4 TO AsteroidAmount - 1
    Ast(a).Owner = -1
    NEXT
 
TYPE ShipType
  x                AS DOUBLE
  y                AS DOUBLE
  xm               AS DOUBLE
  ym               AS DOUBLE
  xt               AS DOUBLE
  yt               AS DOUBLE
  Thick            AS INTEGER
  Owner            AS INTEGER  ' -1ne 0wreck 1kaled 2zileas 3houri 4vamp
  Asteroid         AS INTEGER  ' na kojem mjestu u asteroidu je brod

  Hull             AS INTEGER  ' -1ne postoji 0wreck
                               ' 1light 2advanced 3heavy
                               ' 4offensive support 5defensive support
  Class            AS INTEGER  ' -1ne postoji 0ship 1fighter 2defender
                               ' 3interceptor 4spellcaster

  Weapon1          AS INTEGER
  Weapon2          AS INTEGER
  Weapon3          AS INTEGER
                               ' -1 nista
                               '  0 Kbasic1  3 Zbasic1  6 Hbasic1  9 advK
                               '  1 Kbasic2  4 Zbasic2  7 Hbasic2 10 advZ
                               '  2 Kbasic3  5 Zbasic3  8 Hbasic3 11 advH
  Equipment1       AS INTEGER
  Equipment2       AS INTEGER
                               ' -1 nista
                               '  0 Kbasic1  3 Zbasic1  6 Hbasic1  9 advK
                               '  1 Kbasic2  4 Zbasic2  7 Hbasic2 10 advZ
                               '  2 Kbasic3  5 Zbasic3  8 Hbasic3 11 advH
  Magic            AS INTEGER
                               ' -1 nista    0 magic sealed
                               '  1 fire offensive
                               '  2 wind offensive ....

  HealthMax        AS INTEGER
  Health           AS INTEGER
  EnergyMax        AS INTEGER
  Energy           AS INTEGER

  ExperienceBase   AS LONG
  Experience       AS LONG
  AttackBase       AS DOUBLE
  Attack           AS DOUBLE
  DefenseBase      AS DOUBLE
  Defense          AS DOUBLE
  AgilityBase      AS DOUBLE
  Agility          AS DOUBLE
  IntelligenceBase AS DOUBLE
  Intelligence     AS DOUBLE
END TYPE
DIM SHARED Ship(ShipAmount) AS ShipType

  FOR a = 0 TO ShipAmount - 1
    Ship(a).x = 640
    Ship(a).y = 480
    Ship(a).xm = 0
    Ship(a).ym = 0
    Ship(a).xt = 0
    Ship(a).yt = 0
    Ship(a).Thick = INT(RND * ShipThick)
    Ship(a).Owner = -1
    Ship(a).Asteroid = -1
    Ship(a).Hull = -1
    Ship(a).Class = -1
    Ship(a).Weapon1 = -1
    Ship(a).Weapon2 = -1
    Ship(a).Weapon3 = -1
    Ship(a).Equipment1 = -1
    Ship(a).Equipment2 = -1
    Ship(a).Magic = -1
    Ship(a).HealthMax = -1
    Ship(a).Health = -1
    Ship(a).EnergyMax = -1
    Ship(a).Energy = -1
    Ship(a).ExperienceBase = -1
    Ship(a).Experience = -1
    Ship(a).AttackBase = -1
    Ship(a).Attack = -1
    Ship(a).DefenseBase = -1
    Ship(a).Defense = -1
    Ship(a).AgilityBase = -1
    Ship(a).Agility = -1
    Ship(a).IntelligenceBase = -1
    Ship(a).Intelligence = -1
    NEXT

  FOR a = 0 TO 20
    Ship(a).x = RND * 640 + 320
    Ship(a).y = RND * 480 + 240
    Ship(a).xm = 0
    Ship(a).ym = 0
    Ship(a).xt = 0
    Ship(a).yt = 0

    Ship(a).Thick = INT(RND * ShipThick)
    Ship(a).Owner = PlayerRace
    Ship(a).Asteroid = INT(RND * AsteroidAmount)
    AstSlot(Ship(a).Asteroid, INT(RND * 9)) = a
    Ship(a).Hull = INT(RND * 3)
    Ship(a).Class = INT(RND * 6)
    Ship(a).Weapon1 = -1
    Ship(a).Weapon2 = -1
    Ship(a).Weapon3 = -1
    Ship(a).Equipment1 = -1
    Ship(a).Equipment2 = -1
    Ship(a).Magic = -1
    Ship(a).HealthMax = 40 + Ship(a).Class * 20
    Ship(a).Health = 30 + Ship(a).Class * 20
    Ship(a).EnergyMax = 40 + Ship(a).Class * 20
    Ship(a).Energy = 10
    Ship(a).ExperienceBase = 0
    Ship(a).Experience = 0
    Ship(a).AttackBase = 70
    Ship(a).Attack = 70
    Ship(a).DefenseBase = 70
    Ship(a).Defense = 70
    Ship(a).AgilityBase = 50
    Ship(a).Agility = 50
    Ship(a).IntelligenceBase = 40
    Ship(a).Intelligence = 40
    NEXT
 
       
 
  Ast(0).Owner = 1: Ast(0).Experience = 800
  Ast(1).Owner = 2: Ast(1).Experience = 800
  Ast(2).Owner = 3: Ast(2).Experience = 800

 ' FOR a = 0 TO AsteroidAmount - 1
 '   Ast(a).Owner = INT(RND * 3) + 1
 '   Ast(a).Experience = 800
 '   NEXT

  FOR a = 0 TO 2
    Ast(a).Owner = a + 1
    Ast(a).Experience = 800
    NEXT


 
SetLocation rx / 2, ry / 2
Future.MouseOn

ON TIMER(1) GOSUB FPSSub
TIMER ON

DO

  t = TIMER
  Thick = Thick + 1
  IF Thick >= Day THEN EndTurn

  rot = rot + .1
  IF rot > 2 * pi THEN rot = rot - 2 * pi
 
  mb = mb + 1
  IF mb >= 24 THEN mb = 0
 
  lb = lb / 2
  IF lb <= 0 THEN lb = 32768
  IF lb >= 256 THEN
    LinesBitScan = lb - lb / 256
    ELSE
    LinesBitScan = -(lb * 256 - lb + 1)
    END IF
 
  p = p + 1
  IF p > Pages THEN p = 0
  SetPage p
  x = Future.MouseX
  y = Future.MouseY
  mt1 = ""
  mt2 = ""

  IF x >= rx / 4 * 3 THEN sx = sx + (x - rx / 4 * 3) / 16: IF sx > 1280 - rx THEN sx = 1280 - rx
  IF x < rx / 4 THEN sx = sx + (x - rx / 4) / 16: IF sx < 0 THEN sx = 0
  IF y >= ry / 4 * 3 THEN sy = sy + (y - ry / 4 * 3) / 12: IF sy > 960 - ry THEN sy = 960 - ry
  IF y < ry / 4 THEN sy = sy + (y - ry / 4) / 12: IF sy < 0 THEN sy = 0
 
  SetMaskColor -1
  Future.XMSput -sx / 2, -sy / 2, Pic.Scr
  Future.XMSput -sx / 2 + rx / 4 * 3, -sy / 2, Pic.Scr
  Future.XMSput -sx / 2, -sy / 2 + ry / 4 * 3, Pic.Scr
  Future.XMSput -sx / 2 + rx / 4 * 3, -sy / 2 + ry / 4 * 3, Pic.Scr
 
  IF GalaxyBackground <> -1 THEN SetMaskColor 0: Future.XMSput -sx / 4 + 80, -sy / 4 + 60, Pic.Back
 
  IF TrajectoryLines <> -1 THEN
    FOR a = 0 TO AsteroidAmount - 1
      Arrow Ast(a).x - sx, Ast(a).y - sy, Ast(a).x - sx + COS(Ast(a).Move) * 20, Ast(a).y - sy - SIN(Ast(a).Move) * 20, 30, 43 + PlayerColor
      Future.LINE Ast(a).x + COS(Ast(a).Move) * 32 - sx, Ast(a).y - SIN(Ast(a).Move) * 32 - sy, Ast(a).x + COS(Ast(a).Move) * 256 - sx, Ast(a).y - SIN(Ast(a).Move) * 256 - sy, 43 + PlayerColor, LinesBitScan
      NEXT
    END IF

  SetMaskColor 216
  FOR a = 0 TO AsteroidAmount - 1
    Ast(a).x = Ast(a).x + COS(Ast(a).Move) / 8
    Ast(a).y = Ast(a).y - SIN(Ast(a).Move) / 8

    IF Ast(a).Owner <> -1 AND Ast(a).x > sx - 40 AND Ast(a).x <= sx + rx + 40 AND Ast(a).y > sy - 30 AND Ast(a).y <= sy + ry + 30 THEN
     
      Ast(a).FrameNumber = Ast(a).FrameNumber + 1
      IF Ast(a).FrameNumber >= AsteroidFrameAmount THEN Ast(a).FrameNumber = 0
      Future.XMSArrayPut Ast(a).x - sx - AsteroidFrameSize / 2, Ast(a).y - sy - AsteroidFrameSize / 2, Pic.AstAni, Ast(a).FrameNumber + Ast(a).Animation * AsteroidFrameAmount

      IF s = a THEN
        Spin Ast(a).x - sx, Ast(a).y - sy, 3, 37, PlayerColor
        Spin Ast(a).x - sx, Ast(a).y - sy, 2, 40, Ast(a).MagicColor
        IF Ast(a).Owner = 0 THEN f = 43 ELSE f = 6 ^ (Ast(a).Owner - 1)
        Spin Ast(a).x - sx, Ast(a).y - sy, 1, 43, f
        END IF

      IF Ast(a).Owner > 0 THEN
        Future.XMSArrayPut Ast(a).x - sx + 9, Ast(a).y - sy + 9, Pic.Small, Ast(a).Owner - 1
        Spin Ast(a).x - sx + 24, Ast(a).y - sy + 24, 3, 16, 6 ^ (Ast(a).Owner - 1)
        END IF

      IF Ast(a).InRange = -1 THEN center Ast(a).x - sx, Ast(a).y - sy, "Not in range", 215

      Ast(a).ArrowColor = Ast(a).ArrowColor - .2
      IF Ast(a).ArrowColor < 1 THEN Ast(a).ArrowColor = 5
      Arrow Ast(a).x - sx, Ast(a).y - sy, Ast(a).x - sx + COS(Ast(a).Move) * 20, Ast(a).y - sy - SIN(Ast(a).Move) * 20, 80 - Ast(a).ArrowColor * 10, INT(Ast(a).ArrowColor) * 43

      END IF
     
    NEXT

  FOR a = 0 TO 8
    IF ShipSelect(a) <> -1 AND s <> -1 AND ms = 3 THEN Circ Ship(ShipSelect(a)).x - sx, Ship(ShipSelect(a)).y - sy, 4, 13, 43
    IF ShipSelect(a) <> -1 AND s <> -1 AND ms = 31 THEN Circ Ship(ShipSelect(a)).x - sx, Ship(ShipSelect(a)).y - sy, 4, 13, PlayerColor
    NEXT
 
  SetMaskColor 0
  FOR a = 0 TO ShipAmount - 1
    IF Ship(a).Owner <> -1 THEN

      Ship(a).x = Ship(a).x + Ship(a).xm * Ship(a).Agility / 64
      Ship(a).y = Ship(a).y + Ship(a).ym * Ship(a).Agility / 64
      IF Ship(a).xm < Ship(a).xt THEN Ship(a).xm = Ship(a).xm + Ship(a).Agility / 640
      IF Ship(a).xm > Ship(a).xt THEN Ship(a).xm = Ship(a).xm - Ship(a).Agility / 640
      IF Ship(a).ym < Ship(a).yt THEN Ship(a).ym = Ship(a).ym + Ship(a).Agility / 640
      IF Ship(a).ym > Ship(a).yt THEN Ship(a).ym = Ship(a).ym - Ship(a).Agility / 640

      Ship(a).Thick = Ship(a).Thick + 1
      IF Ship(a).Thick >= ShipThick THEN
        Ship(a).Thick = 0
        c = -Ship(a).x + Ast(Ship(a).Asteroid).x
        d = -Ship(a).y + Ast(Ship(a).Asteroid).y
        IF ABS(c) >= ABS(d) THEN
          Ship(a).yt = d / ABS(c) * 2 / 3
          Ship(a).xt = SGN(c) - ABS(d / c / 2) * SGN(c)
          END IF
        IF ABS(d) > ABS(c) THEN
          Ship(a).xt = c / ABS(d) * 2 / 3
          Ship(a).yt = SGN(d) - ABS(c / d / 2) * SGN(d)
          END IF
        END IF
    
      IF Ship(a).x > sx - 30 AND Ship(a).x <= sx + rx + 30 AND Ship(a).y > sy - 30 AND Ship(a).y <= sy + ry + 30 THEN
        Future.XMSArrayPut Ship(a).x - sx - 4, Ship(a).y - sy - 7, Pic.ShipSmall, 6 * (Ship(a).Owner - 1) + Ship(a).Hull
        END IF
 
      END IF
    NEXT
 
  FOR a = 0 TO ParticleAmount - 1
    IF Part(a).Exist > 0 THEN
      b = COS(Part(a).Move) * Part(a).Exist / Part(a).Spd / Part(a).Size
      c = SIN(Part(a).Move) * Part(a).Exist / Part(a).Spd / Part(a).Size
      Future.LINE Part(a).x - sx, Part(a).y - sy, Part(a).x - sx + b, Part(a).y - sy - c, Part(a).Exist, -1
      Part(a).x = Part(a).x + b
      Part(a).y = Part(a).y - c
      IF Thick MOD Part(a).Spd = 0 THEN IF Part(a).Exist > 5 THEN Part(a).Exist = Part(a).Exist - 6 ELSE Part(a).Exist = Part(a).Exist - 1
      END IF
    NEXT

  FOR a = 0 TO CollisionAmount - 1
    IF Coll(a).Exist <> -1 THEN
      IF Coll(a).Exist = 0 AND CollisionWarning <> -1 THEN
        Arrow -sx + (Ast(Coll(a).a).x + Ast(Coll(a).b).x) / 2, -sy + (Ast(Coll(a).a).y + Ast(Coll(a).b).y) / 2, Ast(Coll(a).a).x - sx, Ast(Coll(a).a).y - sy, 11, 28
        Arrow -sx + (Ast(Coll(a).a).x + Ast(Coll(a).b).x) / 2, -sy + (Ast(Coll(a).a).y + Ast(Coll(a).b).y) / 2, Ast(Coll(a).b).x - sx, Ast(Coll(a).b).y - sy, 11, 93
        END IF
      IF Coll(a).Exist >= 1 THEN center -sx + Coll(a).x, -sy + Coll(a).y, "Colission", 43 * Coll(a).Exist
      END IF
    NEXT

  IF s <> -1 THEN AsteroidOptions

  Future.PRINT 11, 11, STR$(Turn) + STR$(CurrentFrameRate), 0, -1
  Future.PRINT 10, 10, STR$(Turn) + STR$(CurrentFrameRate), 215, -1
  Future.HLINE 28, 16, 46, 14
  Future.HLINE 29, 16, 46, 14
  Future.HLINE 28, 16, 16 + Thick / Day * 30, 28
  Future.HLINE 29, 16, 16 + Thick / Day * 30, 28

  IF z = 2 THEN s = -1
  IF z = 1 AND s = -1 THEN
    FOR a = 0 TO AsteroidAmount - 1
      IF SQR((Ast(a).x - sx - x) ^ 2 + (Ast(a).y - sy - y) ^ 2) < 32 AND Ast(a).InRange <> -1 AND Ast(a).Owner <> -1 THEN
        s = a
        ms = -1
        up = 1
        END IF
      NEXT
    END IF

  IF mt1 <> "" THEN center x + 20, y + 40, mt1, PlayerColor + 172: center x + 20, y + 50, mt2, PlayerColor + 129
 
  SELECT CASE UCASE$(INKEY$)
    CASE "L"
      TrajectoryLines = ABS(TrajectoryLines) - 1
    CASE "G"
      GalaxyBackground = ABS(GalaxyBackground) - 1
    CASE "C"
      CollisionWarning = ABS(CollisionWarning) - 1
    CASE "T"
      Future.SNAPSHOT "SnapShot.BMP"
    CASE "S"
      IF s <> -1 THEN
        FOR a = 0 TO 8
          IF AstSlot(s, a) <> -1 THEN ShipSelect(a) = AstSlot(s, a)
          NEXT
        END IF
    CASE "M"
      FOR a = 0 TO 8
        IF ShipSelect(a) <> -1 AND ms = 3 THEN ms = 31
        NEXT
    CASE CHR$(27)
      TIMER OFF
      DeallocateXMS Pic.Scr
      DeallocateXMS Pic.Back
      DeallocateXMS Pic.Mineral
      DeallocateXMS Pic.LnAni
      DeallocateXMS Pic.Small
      DeallocateXMS Pic.AstAni
      DeallocateXMS Pic.InfoBack
      DeallocateXMS Pic.BaseBack
      DeallocateXMS Pic.Ship
      DeallocateXMS Pic.ShipBack
      DeallocateXMS Pic.ShipInfo
      DeallocateXMS Pic.ShipSmall
      Future.MouseOff
      ReSetScreen
      OUT &H0, 55      ' ShutDownDS4QB
      END
    END SELECT

  ViewPage p
  FPS = FPS + 1
 
  IF z <> up THEN up = 0
  z = 0
  DO
    Future.UpdateMouse
    IF z = 0 THEN z = Future.MouseB
    LOOP UNTIL TIMER <> t
   ' LOOP UNTIL ABS(t - TIMER) > 1 / 8
 
  LOOP

FPSSub:
  CurrentFrameRate = FPS
  FPS = 0
  RETURN

'   Mis Podaci
    DATA 8,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,0,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,215,0,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,0,172,0,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,172,0,0,129,0,8,8,8,8,8,8,8,8,8,8
    DATA 0,129,0,8,0,86,0,8,8,8,8,8,8,8,8,8
    DATA 0,86,0,8,8,0,129,0,8,8,8,8,8,8,8,8
    DATA 0,86,0,8,8,8,0,172,0,8,8,8,8,8,8,8
    DATA 0,86,0,8,8,0,0,0,215,0,8,8,8,8,8,8
    DATA 0,129,0,8,0,86,129,172,215,215,0,8,8,8,8,8
    DATA 0,172,0,0,129,0,0,0,0,0,0,8,8,8,8,8
    DATA 0,215,0,172,0,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,215,0,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,0,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8

    DATA 8,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,0,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,173,0,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,173,0,131,0,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,131,0,0,89,0,8,8,8,8,8,8,8,8,8,8
    DATA 0,89,0,8,0,47,0,8,8,8,8,8,8,8,8,8
    DATA 0,47,0,8,8,0,89,0,8,8,8,8,8,8,8,8
    DATA 0,5,0,8,8,8,0,131,0,8,8,8,8,8,8,8
    DATA 0,47,0,8,8,0,0,0,173,0,8,8,8,8,8,8
    DATA 0,89,0,8,0,47,89,131,173,215,0,8,8,8,8,8
    DATA 0,131,0,0,89,0,0,0,0,0,0,8,8,8,8,8
    DATA 0,173,0,131,0,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,173,0,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,0,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8

    DATA 8,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,0,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,178,0,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,178,0,135,0,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,135,0,0,98,0,8,8,8,8,8,8,8,8,8,8
    DATA 0,98,0,8,0,55,0,8,8,8,8,8,8,8,8,8
    DATA 0,55,0,8,8,0,98,0,8,8,8,8,8,8,8,8
    DATA 0,18,0,8,8,8,0,135,0,8,8,8,8,8,8,8
    DATA 0,55,0,8,8,0,0,0,178,0,8,8,8,8,8,8
    DATA 0,98,0,8,0,55,98,135,178,215,0,8,8,8,8,8
    DATA 0,135,0,0,98,0,0,0,0,0,0,8,8,8,8,8
    DATA 0,178,0,135,0,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,178,0,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,0,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8

    DATA 8,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,0,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,208,0,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,208,0,201,0,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,201,0,0,194,0,8,8,8,8,8,8,8,8,8,8
    DATA 0,194,0,8,0,187,0,8,8,8,8,8,8,8,8,8
    DATA 0,187,0,8,8,0,194,0,8,8,8,8,8,8,8,8
    DATA 0,180,0,8,8,8,0,201,0,8,8,8,8,8,8,8
    DATA 0,187,0,8,8,0,0,0,208,0,8,8,8,8,8,8
    DATA 0,194,0,8,0,187,194,201,208,215,0,8,8,8,8,8
    DATA 0,201,0,0,194,0,0,0,0,0,0,8,8,8,8,8
    DATA 0,208,0,201,0,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,208,0,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,215,0,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 0,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8
    DATA 8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8

DEFSNG A-Z
SUB Arrow (x1 AS INTEGER, y1 AS INTEGER, x3 AS INTEGER, y3 AS INTEGER, Lenght AS INTEGER, col AS LONG)
 
  x2 = x3 - x1
  y2 = y3 - y1
  g = SQR(x2 ^ 2 + y2 ^ 2)
  IF g > 0 THEN
    Future.LINE x1 + x2 / g * (Lenght - 5) - y2 / g * 5, y1 + y2 / g * (Lenght - 5) + x2 / g * 5, x1 + x2 / g * Lenght, y1 + y2 / g * Lenght, col, -1
    Future.LINE x1 + x2 / g * (Lenght - 5) + y2 / g * 5, y1 + y2 / g * (Lenght - 5) - x2 / g * 5, x1 + x2 / g * Lenght, y1 + y2 / g * Lenght, col, -1
    Future.LINE x1 + x2 / g * (Lenght - 5) - y2 / g * 5, y1 + y2 / g * (Lenght - 5) + x2 / g * 5, x1 + x2 / g * (Lenght - 5) + y2 / g * 5, y1 + y2 / g * (Lenght - 5) - x2 / g * 5, col, -1
    END IF

END SUB

SUB AsteroidOptions

 ' b = SQR((Ast(s).x - sx - x) ^ 2 + (Ast(s).y - sy - y) ^ 2)
 ' IF b > 64 THEN
 '   a = INT((b - 64) / 10) + 1
 '   IF a > 5 THEN a = 5
 '   Arrow x, y, Ast(s).x - sx, Ast(s).y - sy, 40, a * 43
 '   END IF


  IF ms = 1 THEN
    SetMaskColor 216
    Future.XMSput 204, 124, Pic.InfoBack
    BOX 202, 122, 438, 358, 43 + PlayerColor
    Future.LINE 200, 0, 200, 479, 86 + PlayerColor, LinesBitScan
    Future.LINE 440, 0, 440, 479, 86 + PlayerColor, LinesBitScan
    Future.LINE 0, 120, 639, 120, 86 + PlayerColor, LinesBitScan
    Future.LINE 0, 360, 639, 360, 86 + PlayerColor, LinesBitScan

    SELECT CASE Ast(s).Owner
      CASE 0
        e = "Uninhabited"
        f = 129
      CASE 1
        e = "Kaled base"
        f = 129 + 2
      CASE 2
        e = "Zileas settlement"
        f = 129 + 12
      CASE 3
        e = "Houri presence"
        f = 129 + 72
      END SELECT
    Future.PRINT 211, 131, e, 0, -1
    Future.PRINT 210, 130, e, f, -1
    SELECT CASE Ast(s).Magic
      CASE 0
        e = "Mineral abnudant"
      CASE 1
        e = "Fire well magic"
      CASE 2
        e = "Wind mark magic"
      CASE 3
        e = "Earth rock magic"
      CASE 4
        e = "Ice brick magic"
      CASE 5
        e = "Water fountain magic"
      CASE 6
        e = "Thunder storm magic"
      END SELECT
    Future.PRINT 211, 151, e, 0, -1
    Future.PRINT 210, 150, e, Ast(s).MagicColor * 2 + 86, -1
  
    Future.FILLBOX 247, 181, 423, 192, 0
    Future.FILLBOX 247, 211, 423, 222, 0
    Future.FILLBOX 247, 241, 423, 252, 0

    BOX 244, 178, 426, 195, 2
    BOX 244, 208, 426, 225, 12
    BOX 244, 238, 426, 255, 72
   
    FOR a = 0 TO 8
      IF mb - a >= 0 AND mb - a < 20 THEN
        IF Ast(s).Metal > a THEN Future.XMSArrayPut 246 + a * 20, 179, Pic.LnAni, mb - a
        IF Ast(s).Fuel > a THEN Future.XMSArrayPut 246 + a * 20, 209, Pic.LnAni, mb - a + 20
        IF Ast(s).Crys > a THEN Future.XMSArrayPut 246 + a * 20, 239, Pic.LnAni, mb - a + 40
        END IF
      
      Future.FILLBOX 213 + a * 25, 278, 227 + a * 25, 302, 0
      BOX 210 + a * 25, 275, 230 + a * 25, 305, PlayerColor + 43
      IF AstSlot(s, a) <> -1 THEN Future.XMSArrayPut 212 + a * 25, 277, Pic.ShipInfo, Ship(AstSlot(s, a)).Hull + (Ship(AstSlot(s, a)).Owner - 1) * 6
      NEXT

    BOX 208, 174, 235, 200, 43 + 1
    BOX 208, 204, 235, 230, 43 + 6
    BOX 208, 234, 235, 260, 43 + 36
    Future.XMSArrayPut 210, 175, Pic.Mineral, 0
    Future.XMSArrayPut 210, 205, Pic.Mineral, 1
    Future.XMSArrayPut 210, 235, Pic.Mineral, 2
    END IF


  IF ms = 2 OR (ms >= 20 AND ms <= 24) THEN
    FOR a = 0 TO 4
      c = 0
      h = PlayerColor + 43
      IF ms - 20 = a THEN h = PlayerColor + 129
      IF x >= 160 + 65 * a AND x <= 220 + 65 * a AND y >= 120 AND y <= 136 THEN
        c = 1
        h = h + 43
        IF z = 1 THEN ms = 20 + a
        END IF
      BOX 160 + 65 * a - c, 120 - c, 220 + 65 * a + c, 136 + c, h
      NEXT

    center 190, 128, "Move", 215
    center 255, 128, "Split", 215
    center 320, 128, "Build", 215
    center 385, 128, "Lab", 215
    center 450, 128, "Ships", 215
    BOX 160, 140, 480, 360, PlayerColor + 43
    Future.XMSput 162, 142, Pic.BaseBack
    Future.PRINT 331 - LEN(STR$(Ast(s).Experience)) * 8, 369, "Base Experience:" + STR$(Ast(s).Experience) + "ep", 0, -1
    Future.PRINT 330 - LEN(STR$(Ast(s).Experience)) * 8, 368, "Base Experience:" + STR$(Ast(s).Experience) + "ep", PlayerColor + 86, -1
    Future.PRINT 458 - LEN(STR$(Ast(s).Experience)) * 8, 368, STR$(Ast(s).Experience), PlayerColor + 172, -1
   
    Future.PRINT 166, 144, "Required ep:", PlayerColor + 86, -1

    IF ms = 20 THEN

      END IF

    IF ms = 21 THEN

      END IF

    IF ms = 22 THEN

      END IF
 
    IF ms = 23 THEN

      END IF

    IF ms = 24 THEN

      END IF

    END IF


  IF ms = 3 THEN

    Future.PRINT 317, 385, "Select All Move Attack", 0, -1
    Future.PRINT 316, 384, "Select All Move Attack", PlayerColor + 86, -1
    Future.PRINT 316, 384, "S          M    A     ", PlayerColor + 172, -1

    FOR a = 0 TO 2
      FOR b = 0 TO 2
       
        h = PlayerColor
        IF ShipSelect(a * 3 + b) <> -1 THEN h = h + 129
        IF AstSlot(s, a * 3 + b) <> -1 AND x > 127 + 128 * b AND y > 95 + 96 * a AND x < 247 + 128 * b AND y < 183 + 96 * a THEN
          IF z = 1 AND up = 0 THEN
            up = 1
            IF ShipSelect(a * 3 + b) = -1 THEN ShipSelect(a * 3 + b) = AstSlot(s, a * 3 + b) ELSE ShipSelect(a * 3 + b) = -1
            END IF
          BOX 127 + 128 * b, 95 + 96 * a, 247 + 128 * b, 183 + 96 * a, h + 43
        ELSE
          BOX 128 + 128 * b, 96 + 96 * a, 246 + 128 * b, 182 + 96 * a, h
          END IF

        Future.XMSput 130 + 128 * b, 98 + 96 * a, Pic.ShipBack
       
        IF AstSlot(s, a * 3 + b) <> -1 THEN
          e = ""
          SELECT CASE Ship(AstSlot(s, a * 3 + b)).Hull
            CASE 3
              e = "Off. Support"
            CASE 4
              e = "Def. Support"
            END SELECT
          SELECT CASE Ship(AstSlot(s, a * 3 + b)).Class
            CASE 0
              e = e + "Regular Ship"
            CASE 1
              e = e + "Fighter"
            CASE 2
              e = e + "Defender"
            CASE 3
              e = e + "Interceptor"
            CASE 4
              e = e + "Spellcaster"
            CASE 5
              e = e + "Vamp Ship"
            END SELECT
          Future.PRINT 132 + 128 * b, 99 + 96 * a, e, 0, -1
          Future.PRINT 131 + 128 * b, 98 + 96 * a, e, 215, -1
          Future.XMSArrayPut 136 + 128 * b, 117 + 96 * a, Pic.Ship, Ship(AstSlot(s, a * 3 + b)).Hull + (Ship(AstSlot(s, a * 3 + b)).Owner - 1) * 6
          END IF

        NEXT
      NEXT
    END IF

  IF ms = 31 THEN
   
    mt1 = "Select"
    mt2 = "Asteroid"
    h = PlayerColor + 86
    c = x
    d = y
    f = -1
    FOR b = 0 TO AsteroidAmount - 1
      IF SQR((Ast(b).x - sx - x) ^ 2 + (Ast(b).y - sy - y) ^ 2) < 32 AND Ast(b).InRange <> -1 AND Ast(b).Owner <> -1 THEN
        c = Ast(b).x - sx
        d = Ast(b).y - sy
        h = PlayerColor + 172
        f = b
        IF (Ast(f).Owner = PlayerRace OR Ast(f).Owner = 0) THEN mt1 = "Confirm" ELSE mt1 = "Invalid"
        mt2 = "Destination"
        END IF
      NEXT
   
    g = 0
    FOR a = 0 TO 8
      IF ShipSelect(a) <> -1 THEN
        Future.LINE Ship(ShipSelect(a)).x - sx, Ship(ShipSelect(a)).y - sy, c, d, h, LinesBitScan
        IF z = 1 AND f <> -1 THEN
          ms = 3

          WHILE g < 9 AND ShipSelect(a) <> -1 AND (Ast(f).Owner = PlayerRace OR Ast(f).Owner = 0)
            IF AstSlot(f, g) = -1 THEN
              AstSlot(f, g) = ShipSelect(a)
              Ship(ShipSelect(a)).Asteroid = f
              AstSlot(s, a) = -1
              ShipSelect(a) = -1
              END IF
            g = g + 1
            WEND
         
          END IF
        END IF
      NEXT

    END IF


  IF ms = -1 THEN
    a = -1

    IF Ast(s).Owner = PlayerRace THEN

      IF SQR((Ast(s).x - sx - x) ^ 2 + (Ast(s).y - sy - 40 - y) ^ 2) < 20 THEN
        BOX Ast(s).x - sx - 25, Ast(s).y - sy - 49, Ast(s).x - sx + 25, Ast(s).y - sy - 31, 88
        a = 0
      ELSE
        BOX Ast(s).x - sx - 24, Ast(s).y - sy - 48, Ast(s).x - sx + 24, Ast(s).y - sy - 32, 45
        END IF

      IF SQR((Ast(s).x - sx + 50 - x) ^ 2 + (Ast(s).y - sy - y) ^ 2) < 24 THEN
        BOX Ast(s).x - sx + 29, Ast(s).y - sy - 9, Ast(s).x - sx + 71, Ast(s).y - sy + 9, 129
        a = 2
      ELSE
        BOX Ast(s).x - sx + 30, Ast(s).y - sy - 8, Ast(s).x - sx + 70, Ast(s).y - sy + 8, 86
        END IF

      center Ast(s).x - sx + 50, Ast(s).y - sy, "base", 215
      center Ast(s).x - sx, Ast(s).y - sy - 40, "magic", 215
     
      END IF
   
    IF SQR((Ast(s).x - sx - 50 - x) ^ 2 + (Ast(s).y - sy - y) ^ 2) < 24 THEN
      BOX Ast(s).x - sx - 71, Ast(s).y - sy - 9, Ast(s).x - sx - 29, Ast(s).y - sy + 9, 98
      a = 1
    ELSE
      BOX Ast(s).x - sx - 70, Ast(s).y - sy - 8, Ast(s).x - sx - 30, Ast(s).y - sy + 8, 55
      END IF
   
    IF SQR((Ast(s).x - sx - x) ^ 2 + (Ast(s).y - sy + 40 - y) ^ 2) < 20 THEN
      BOX Ast(s).x - sx - 25, Ast(s).y - sy + 31, Ast(s).x - sx + 25, Ast(s).y - sy + 49, 158
      FOR b = 0 TO 8
        ShipSelect(b) = -1
        NEXT
      a = 3
    ELSE
      BOX Ast(s).x - sx - 24, Ast(s).y - sy + 32, Ast(s).x - sx + 24, Ast(s).y - sy + 48, 115
      END IF

    center Ast(s).x - sx - 50, Ast(s).y - sy, "info", 215
    center Ast(s).x - sx, Ast(s).y - sy + 40, "fleet", 215
   
    IF z = 1 THEN ms = a: up = 1
    END IF

END SUB

DEFINT A-Z
SUB BOX (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, col AS INTEGER)

  Future.BOX x1, y1, x2, y2, col
  Future.BOX x1 + 1, y1 + 1, x2 - 1, y2 - 1, 0
  Future.BOX x1 - 1, y1 - 1, x2 + 1, y2 + 1, 0

 ' Future.HLINE y1 - 1, x1 + 1, x2 - 1, 0
 ' Future.HLINE y2 + 1, x1 + 1, x2 - 1, 0
 ' Future.LINE x1 - 1, y1 + 1, x1 - 1, y2 - 1, 0, -1
 ' Future.LINE x2 + 1, y1 + 1, x2 + 1, y2 - 1, 0, -1
 ' Future.BOX x1 + 1, y1 + 1, x2 - 1, y2 - 1, 0
 ' Future.HLINE y1, x1 + 1, x2 - 1, col
 ' Future.HLINE y2, x1 + 1, x2 - 1, col
 ' Future.LINE x1, y1 + 1, x1, y2 - 1, col, -1
 ' Future.LINE x2, y1 + 1, x2, y2 - 1, col, -1
 ' Future.PSET x1, y1, 0
 ' Future.PSET x1, y2, 0
 ' Future.PSET x2, y1, 0
 ' Future.PSET x2, y2, 0
 ' Future.PSET x1 + 1, y1 + 1, col
 ' Future.PSET x1 + 1, y2 - 1, col
 ' Future.PSET x2 - 1, y1 + 1, col
 ' Future.PSET x2 - 1, y2 - 1, col

END SUB

DEFSNG A-Z
SUB center (x1 AS INTEGER, y1 AS INTEGER, text AS STRING, col AS LONG)
 
  IF x1 >= 0 AND y1 >= 0 AND x1 < rx AND y1 < ry THEN
    x1 = x1 - LEN(text) * 4
    y1 = y1 - 7
    Future.PRINT x1 + 1, y1 + 1, text, 0, -1
    Future.PRINT x1, y1, text, col, -1
    END IF

END SUB

DEFINT A-Z
SUB Circ (x1 AS DOUBLE, y1 AS DOUBLE, speed AS DOUBLE, range AS INTEGER, col AS LONG)

  Future.CIRCLE x1, y1, range - 1, col
  Future.CIRCLE x1, y1, range - 2, col + 43
  FOR i = 0 TO 7
    Future.LINE x1 + COS(-rot + pi / 4 * i) * range, y1 - SIN(-rot + pi / 4 * i) * range, x1 + COS(-rot + pi / 4 * i) * (range + speed), y1 - SIN(-rot + pi / 4 * i) * (range + speed), INT(i / 2 + 1) * col + 43, -1
    NEXT

END SUB

DEFSNG A-Z
SUB EndTurn
 
  Thick = 0
  Turn = Turn + 1
  FOR a = 0 TO AsteroidAmount - 1
    IF Ast(a).x < -40 OR Ast(a).x > 1320 OR Ast(a).y < -20 OR Ast(a).y > 980 THEN Ast(a).Owner = -1
   
    IF Ast(a).Owner <> -1 THEN
      Ast(a).Experience = Ast(a).Experience + 1
      END IF

    IF Ast(a).Owner = -1 THEN
      Ast(a).Animation = INT(RND * 10)
      Ast(a).FrameNumber = INT(RND * AsteroidFrameAmount)
      Ast(a).Metal = INT(RND * 6) + 4
      Ast(a).Fuel = INT(RND * 6) + 4
      Ast(a).Crys = INT(RND * 6) + 4
      Ast(a).Magic = INT(RND * 7)
      SELECT CASE Ast(a).Magic
        CASE 0
          Ast(a).Metal = 9
          Ast(a).Fuel = 9
          Ast(a).Crys = 9
          Ast(a).MagicColor = 43
        CASE 1
          Ast(a).MagicColor = 1
        CASE 2
          Ast(a).MagicColor = 1 + 6
        CASE 3
          Ast(a).MagicColor = 6
        CASE 4
          Ast(a).MagicColor = 6 + 36
        CASE 5
          Ast(a).MagicColor = 36
        CASE 6
          Ast(a).MagicColor = 36 + 1
        END SELECT
      Ast(a).Owner = 0
      Ast(a).Magic = INT(RND * 7)
      Ast(a).InRange = -1
      Ast(a).ArrowColor = RND * 4 + 1
      b = INT(RND * 2)
      IF INT(RND * 2) = 0 THEN
        Ast(a).x = INT(RND * 1280)
        Ast(a).y = 960 * b
        Ast(a).Move = pi / 2 * RND + pi / 4 * 5 - pi * b
        IF Ast(a).x <= rx / 3 * 2 THEN Ast(a).Move = Ast(a).Move - pi / 6 * SGN(b - 1 / 2)
        IF Ast(a).x >= rx / 3 * 4 THEN Ast(a).Move = Ast(a).Move + pi / 6 * SGN(b - 1 / 2)
        ELSE
        Ast(a).x = 1280 * b
        Ast(a).y = INT(RND * 960)
        Ast(a).Move = pi / 2 * RND + pi / 4 * 7 - pi * b
        IF Ast(a).y <= ry / 3 * 2 THEN Ast(a).Move = Ast(a).Move + pi / 8 * SGN(b - 1 / 2)
        IF Ast(a).y >= ry / 3 * 4 THEN Ast(a).Move = Ast(a).Move - pi / 8 * SGN(b - 1 / 2)
        END IF
      END IF
   
    Ast(a).InRange = 0
    IF Ast(a).x < 60 OR Ast(a).x >= 1220 OR Ast(a).y < 50 OR Ast(a).y >= 910 THEN
      Ast(a).Owner = 0
      Ast(a).InRange = -1
      IF s = a THEN s = -1
      c = 0
      FOR b = 0 TO 8
        IF AstSlot(a, b) <> -1 THEN
          FOR d = c TO ParticleAmount - 1 STEP 9
            Part(d).x = Ship(AstSlot(a, b)).x
            Part(d).y = Ship(AstSlot(a, b)).y
            Part(d).Exist = 6 * INT(6 * RND) + INT(6 * RND)
            IF Part(d).Exist = 0 THEN Part(d).Exist = 35
            Part(d).Move = 2 * pi * RND
            Part(d).Spd = INT(RND * 6) + 6
            Part(d).Size = 2
            NEXT
          Ship(AstSlot(a, b)).Owner = -1
          AstSlot(a, b) = -1
          c = c + 1
          END IF
        NEXT
      END IF

    NEXT
  FOR a = 0 TO CollisionAmount - 1
    Coll(a).Exist = Coll(a).Exist - 1
    IF Coll(a).Exist <= 0 THEN Coll(a).Exist = -1
    NEXT
  d = 1
  FOR a = 0 TO AsteroidAmount - 1
    FOR b = 0 TO a - 1
      IF SQR((Ast(a).x - Ast(b).x) ^ 2 + (Ast(a).y - Ast(b).y) ^ 2) < 100 AND Ast(a).Owner <> -1 THEN
        cb = cb + 1
        IF cb >= CollisionAmount THEN cb = 0
        Coll(cb).Exist = 0
        Coll(cb).a = a
        Coll(cb).b = b
        IF SQR((Ast(a).x - Ast(b).x) ^ 2 + (Ast(a).y - Ast(b).y) ^ 2) < 40 THEN
          Coll(cb).Exist = 5
          Coll(cb).x = (Ast(a).x + Ast(b).x) / 2
          Coll(cb).y = (Ast(a).y + Ast(b).y) / 2
          Ast(a).Owner = -1
          Ast(b).Owner = -1
          IF s = a OR s = b THEN s = -1
          IF Part(0).Exist > 0 THEN d = d + 1
          FOR c = 0 TO ParticleAmount STEP d
            Part(c).x = (Ast(a).x + Ast(b).x) / 2
            Part(c).y = (Ast(a).y + Ast(b).y) / 2
            Part(c).Exist = 6 * INT(6 * RND) + INT(6 * RND)
            IF Part(c).Exist = 0 THEN Part(c).Exist = 35
            Part(c).Move = 2 * pi * RND
            Part(c).Spd = INT(RND * 4) + 4
            Part(c).Size = 1
            NEXT
          END IF
        END IF
      NEXT
    NEXT
  FOR a = 0 TO CollisionAmount - 1
    IF Coll(a).Exist = 0 AND (Ast(Coll(a).a).Owner = -1 OR Ast(Coll(a).b).Owner = -1) THEN Coll(a).Exist = -1
    NEXT

END SUB

SUB LoadMusic (MusicName AS STRING, MusicType AS INTEGER, MusicChannel AS INTEGER, Repeat AS INTEGER, Enable3D AS INTEGER)
WaitforDMA0
OPEN "music\DS4QB2.DAT" FOR OUTPUT AS #1
PRINT #1, MusicName
PRINT #1, MusicType
PRINT #1, MusicChannel
PRINT #1, Repeat
PRINT #1, Enable3D
CLOSE #1
OUT &H0, 1
OUT &H0, 1
END SUB

SUB LoadSample
WaitforDMA0
OUT &H0, 3
OUT &H0, 3
END SUB

SUB PlaySample (SFXT AS INTEGER)
OUT &H0, SFXT + 55
OUT &H0, SFXT + 55
END SUB

SUB RemoveMusic (Channel AS INTEGER)
WaitforDMA0
OPEN "music\DS4QB2.DAT" FOR OUTPUT AS #1
PRINT #1, Channel
CLOSE #1
OUT &H0, 2
OUT &H0, 2
END SUB

SUB SetEAX (EaxCode AS INTEGER)
WaitforDMA0
OPEN "music\DS4QB2.DAT" FOR OUTPUT AS #1
PRINT #1, EaxCode
CLOSE #1
OUT &H0, 5
OUT &H0, 5
END SUB

SUB SetVolume (MODVol AS INTEGER, SAMVol AS INTEGER, MP3Vol AS INTEGER)
WaitforDMA0
OPEN "music\DS4QB2.DAT" FOR OUTPUT AS #1
PRINT #1, MODVol
PRINT #1, SAMVol
PRINT #1, MP3Vol
CLOSE #1
OUT &H0, 4
OUT &H0, 4
END SUB

SUB Spin (x1 AS DOUBLE, y1 AS DOUBLE, speed AS DOUBLE, range AS INTEGER, col AS LONG)
 
  FOR i = 0 TO 4
    g = rot * speed + (x1 + y1 + sx + sy) / 3
    Future.LINE x1 + COS(g - (i + 1) / 4) * range, y1 - SIN(g - (i + 1) / 4) * range, x1 + COS(g - i / 4) * range, y1 - SIN(g - i / 4) * range, 215 - (43 - col) * i, -1
    Future.LINE x1 + COS(g - (i + 6) / 4) * range, y1 - SIN(g - (i + 6) / 4) * range, x1 + COS(g - (i + 5) / 4) * range, y1 - SIN(g - (i + 5) / 4) * range, col * (5 - i), -1
    NEXT

END SUB

SUB WaitforDMA0
DO
LOOP UNTIL INP(&H0) = 0
END SUB

